Subject: bug#72303: When emacs-pgtk fails to find a Wayland display available, it fails to run instead of opening in -nw mode

From: Eli Zaretskii <[email-masked]>
Date: Fri, 26 Jul 2024 08:48:18 +0300

> Date: Thu, 25 Jul 2024 20:37:40 -0600
> From: Gunnar Wolf <[email-masked]>
> 
> Package: emacs
> 
> I have Emacs installed in all of my systems. Paricularly, I have
> emacs-pgtk all systems where I often use a graphical environment (and
> emacs-nox in those where I don't).
> 
> Back when I used X11, if I started Emacs and had no $DISPLAY set, it
> would open in a terminal. With emacs-pgtk, the behavior is not the
> same:
> 
>     $ emacs foobar
> 
>     (emacs:3988): Gtk-WARNING **: 19:19:10.887: cannot open display:
>     $
> 
> This impacted me because I neede to use a remote machine to do work
> via scripts (i.e. dch, debcommit) that call /usr/bin/editor and I
> found impossible to hand-specify emacs to use -nw; I ended up
> installing emacs-nox, but I don't find it to be an acceptable,
> transparent-enough solution.
> 
> I think emacs-pgtk should behave just as emacs-gtk, falling back to
> the console if a windowed environment is not found.

This is a known problem with the PGTK build, for which unfortunately
there's no known solution.  See bug#63555 and bug#65886.

Po Lu, it sounds like we need a PROBLEMS entry for this issue, as it
comes up very frequently.